import { FunctionComponent, ReactNode } from 'react';
import {
  SpaceProps,
  ColorProps,
  DisplayProps,
  MaxWidthProps,
  MinWidthProps,
  WidthProps,
  HeightProps,
  MaxHeightProps,
  MinHeightProps,
  VerticalAlignProps,
  FlexProps,
  OrderProps,
  FlexBasisProps,
  AlignSelfProps,
  FontSizeProps,
  BordersProps,
  BorderColorProps,
  BorderRadiusProps,
  BoxShadowProps,
  OpacityProps,
  OverflowProps,
  RatioProps,
  BackgroundProps,
  BackgroundImageProps,
  BackgroundSizeProps,
  BackgroundPositionProps,
  BackgroundRepeatProps,
  PositionProps,
  ZIndexProps,
  LeftProps,
  TopProps,
  RightProps,
  BottomProps,
  FlexWrapProps,
  FlexDirectionProps,
  AlignItemsProps,
  AlignContentProps,
  JustifyContentProps
} from 'styled-system';

export interface StyledFlexProps
  extends SpaceProps,
    ColorProps,
    DisplayProps,
    MaxWidthProps,
    MinWidthProps,
    WidthProps,
    HeightProps,
    MaxHeightProps,
    MinHeightProps,
    VerticalAlignProps,
    FlexProps,
    OrderProps,
    FlexBasisProps,
    AlignSelfProps,
    FontSizeProps,
    BordersProps,
    BorderColorProps,
    BorderRadiusProps,
    BoxShadowProps,
    OpacityProps,
    OverflowProps,
    RatioProps,
    BackgroundProps,
    BackgroundImageProps,
    BackgroundSizeProps,
    BackgroundPositionProps,
    BackgroundRepeatProps,
    PositionProps,
    ZIndexProps,
    LeftProps,
    TopProps,
    RightProps,
    BottomProps,
    FlexWrapProps,
    FlexDirectionProps,
    AlignItemsProps,
    AlignContentProps,
    JustifyContentProps {
  className?: string;
  children?: ReactNode;
  component?: string;
}

declare const StyledFlex: FunctionComponent<StyledFlexProps>;

export default StyledFlex;
